"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Alert = function Alert(_ref) {
	var _ref$type = _ref.type;
	var type = _ref$type === undefined ? "info" : _ref$type;
	var message = _ref.message;
	var headline = _ref.headline;
	var onDismiss = _ref.onDismiss;

	if (["success", "info", "warning", "danger"].indexOf(type) < 0) {
		type = "info";
	}

	var css = "alert alert-dismissible alert-" + type;
	var headlineEl = headline ? _react2.default.createElement(
		"strong",
		null,
		headline,
		" "
	) : null;

	return _react2.default.createElement(
		"div",
		{ className: css },
		_react2.default.createElement(
			"button",
			{ type: "button", className: "close", title: "Dismiss", onClick: onDismiss },
			"×"
		),
		headlineEl,
		message
	);
};

exports.default = Alert;