"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactAddonsCssTransitionGroup = require("react-addons-css-transition-group");

var _reactAddonsCssTransitionGroup2 = _interopRequireDefault(_reactAddonsCssTransitionGroup);

var _alert = require("./alert");

var _alert2 = _interopRequireDefault(_alert);

var _alerts = require("./alerts.styles");

var _alerts2 = _interopRequireDefault(_alerts);

var _jssPreset = require("./jss-preset");

var _jssPreset2 = _interopRequireDefault(_jssPreset);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ENTER_TIMEOUT = 500;
var EXIT_TIMEOUT = 300;

var ReactBsNotifier = function ReactBsNotifier(_ref) {
	var alerts = _ref.alerts;
	var _onDismiss = _ref.onDismiss;
	var sheet = _ref.sheet;
	var classes = sheet.classes;


	return _react2.default.createElement(
		"div",
		{ className: classes.container },
		_react2.default.createElement(
			_reactAddonsCssTransitionGroup2.default,
			{ transitionName: classes, transitionEnterTimeout: ENTER_TIMEOUT, transitionLeaveTimeout: EXIT_TIMEOUT },
			alerts.map(function (item, idx) {
				return _react2.default.createElement(_alert2.default, { key: idx, type: item.type, headline: item.headline, message: item.message, onDismiss: function onDismiss() {
						return _onDismiss(item);
					} });
			})
		)
	);
};

var ReactBsNotifierStateContainer = function (_Component) {
	_inherits(ReactBsNotifierStateContainer, _Component);

	function ReactBsNotifierStateContainer(props) {
		_classCallCheck(this, ReactBsNotifierStateContainer);

		var _this = _possibleConstructorReturn(this, (ReactBsNotifierStateContainer.__proto__ || Object.getPrototypeOf(ReactBsNotifierStateContainer)).call(this, props));

		_this.dismiss = function (item) {
			if (_this.props.onDismiss) {
				// if callback specified, call it
				_this.props.onDismiss(item);
			} else {
				// if no callback for dismissal, just update our state
				var newData = _this.state.dismissedAlerts.slice();
				newData.push(item);
				_this.setState({ dismissedAlerts: newData });
			}
		};

		_this.state = {
			dismissedAlerts: []
		};
		return _this;
	}

	_createClass(ReactBsNotifierStateContainer, [{
		key: "render",
		value: function render() {
			var _this2 = this;

			var alerts = [];

			for (var i = 0; i < this.props.alerts.length; i++) {
				if (this.state.dismissedAlerts.indexOf(this.props.alerts[i]) < 0) {
					(function () {
						var alert = _this2.props.alerts[i];
						alerts.push(alert);

						if (_this2.props.timeout) {
							setTimeout(function () {
								return _this2.dismiss(alert);
							}, _this2.props.timeout + ENTER_TIMEOUT + EXIT_TIMEOUT);
						}
					})();
				}
			}

			return _react2.default.createElement(ReactBsNotifier, { alerts: alerts, onDismiss: this.dismiss, sheet: this.props.sheet });
		}
	}]);

	return ReactBsNotifierStateContainer;
}(_react.Component);

ReactBsNotifierStateContainer.propTypes = {
	alerts: _react.PropTypes.array.isRequired,
	onDismiss: _react.PropTypes.func,
	timeout: _react.PropTypes.number
};

exports.default = (0, _jssPreset2.default)(ReactBsNotifierStateContainer, _alerts2.default, { meta: __filename });